#!/usr/bin/env python
# -*- coding: utf-8 -*-
################################################################################
# Draw the rounded background of any size for conky
# Author: easy2002 (e2002@bk.ru)
# Created: 01/03/2011
# Usage ${execpi 3600 ~/.conky/backgrounds/bg.py -s 306x344}
# Run ~/.conky/backgrounds/bg.py -h for help
################################################################################

from optparse import OptionParser
import os

path = os.path.dirname(os.path.realpath( __file__ ))

parser = OptionParser()
parser.add_option("-s", "--size", dest="bgsize", type="string", default="240x245", metavar="WIDTHxHEIGHT", help=u"Background size in pixels, default 240x245")
parser.add_option("-l", "--left", dest="bgleft", type="int", default=0, metavar="num", help=u"Background left in pixels, default 0")
parser.add_option("-t", "--top", dest="bgtop", type="int", default=0, metavar="num", help=u"Background top in pixels, default 0")
parser.add_option("-n", "--name", dest="templatename", type="string", metavar="templatename", default='defaultbg', help=u"Background template name, default defaultbg")


(options, args) = parser.parse_args()
f = open(path+'/'+options.templatename+'/borders', 'r')
(btop,bright,bbottom,bleft) = map(int,f.readline().split(','))
f.close()
(bgwidth,bgheight) = map(int,options.bgsize.split('x'))
imagestr = '${image %s/%s/%%s.png -p %%s,%%s -s %%sx%%s}' % (path, options.templatename)

bg  = imagestr % ('topleft', options.bgleft, options.bgtop, bleft,btop)
bg += imagestr % ('top', options.bgleft+bleft, options.bgtop, bgwidth-bleft-bright, btop)
bg += imagestr % ('topright', options.bgleft+bgwidth-bright, options.bgtop, bright, btop)
bg += imagestr % ('left', options.bgleft, options.bgtop+btop, bleft, bgheight-btop-bbottom)
bg += imagestr % ('center', options.bgleft+bleft, options.bgtop+btop, bgwidth-bleft-bright, bgheight-btop-bbottom)
bg += imagestr % ('right', options.bgleft+bgwidth-bright, options.bgtop+btop, bright, bgheight-btop-bbottom)
bg += imagestr % ('bottomleft', options.bgleft, options.bgtop+bgheight-bbottom, bleft, bbottom)
bg += imagestr % ('bottom', options.bgleft+bleft, options.bgtop+bgheight-bbottom, bgwidth-bleft-bright, bbottom)
bg += imagestr % ('bottomright', options.bgleft+bgwidth-bright, options.bgtop+bgheight-bbottom, bright, bbottom)
print bg
