#!/usr/bin/env python
# -*- coding: utf-8 -*-
################################################################################
# Calendar script for conky
# Author: easy2002 (e2002@bk.ru)
# Created: 01/03/2011
# Usage ${execpi 30 ~/.conky/x-calendar/x-calendar.py}
################################################################################
# Settings:
bgwidth         = 255           #background width
bgheight        = 285           #background height
bgname          = 'flatfx'   #background name
todayspaceleft  = 42            #for plase today image
todayspacetop   = 164           #for plase today image
letterwidth     = 24            #for plase today image
lineheight      = 20            #for plase today image
month_font      = 'Sans'
days_font       = 'Liberation Mono'
days_font_size  = '10'
voffset         = 110           #calendar vertical offset in pixels
################################################################################

import datetime

def julian_leap ( y= 2000 ) : 
     if ((( y % 4 ) == 0) and (( y % 100 ) != 0) ) : 
         return 29 
     return 28
     
def conky_cal(today):
    global todayspaceleft
    day_per_month = [ 31, 0, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ]
    Month = [ "Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь" ]
    day_per_month[1] = julian_leap(today.year)
    
    fday    = datetime.date(today.year, today.month, 1)
    nofweek = today.isocalendar()[1]-fday.isocalendar()[1]
    if (nofweek<0):
        nofweek=today.isocalendar()[1]
    wday = today.weekday()

    count=fday.weekday()
    if((today.day - today.day % 10)==0):
        todayspaceleft += 5
    result = '${voffset %s}${font %s:bold:size=18}${alignc}%s, %s${font}\n' % (voffset,month_font,Month[today.month-1], today.year)
    result += '${image ~/.conky/x-calendar/images/grid2.png -p 44,168 -s 166x98}${image ~/.conky/x-calendar/images/now2.png -p %s,%s -s 28x28}' %(wday*letterwidth+todayspaceleft,nofweek*lineheight+todayspacetop)
    result += "${voffset 11}${font "+days_font+":size="+days_font_size+"}${alignc}Пн Вт Ср Чт Пт ${color2}Сб Вс${color}\n${voffset 4}${alignc}" + "   " * count
    weekscount = 1
    
    for i in range(day_per_month[today.month-1]):
        if (i<9):
            result = result + " "
        if (i+1 == today.day):
            result = result + "${font "+days_font+":bold:size="+days_font_size+"}${color1}"+ str(i+1)+ "${color}${font "+days_font+":size="+days_font_size+"}"
        else:
            if (count==5 or count==6):
                result = result + "${color2}"+str(i+1)+"${color}"
            else:
                result = result + str(i+1)
        count += 1
        if (count==7):
            result = result + "\n${voffset 4}${alignc}"
            count = 0
            weekscount += 1
        else:
            result = result + " "
    result = result + "   " * (6-count) + "  "
    return (result,weekscount)
################################################################################

today = datetime.datetime.today()
#Test It!
#today = datetime.datetime(2531,5,8,20,58)

hr = today.strftime("%H%M")

(cal,weekscount) = conky_cal(today)
if weekscount != 5:
    bgheight += 20

dgleft = bgwidth / 2 - 92
clock = '${image ~/.conky/x-calendar/images/%s.png -p %s,0 -s 40x100}\
${image ~/.conky/x-calendar/images/%s.png -p %s,0 -s 40x100}\
${image ~/.conky/x-calendar/images/clockbg-blank.png -p %s,0 -s 100x100}\n\
${image ~/.conky/x-calendar/images/%s.png -p %s,0 -s 40x100}\
${image ~/.conky/x-calendar/images/%s.png -p %s,0 -s 40x100}\
${image ~/.conky/x-calendar/images/clockbg-blank.png -p %s,0 -s 100x100}' % (hr[0], dgleft, hr[1], dgleft + 40, dgleft-10, hr[2], dgleft + 100, hr[3], dgleft + 140, dgleft+90)

print '${execp ~/.conky/backgrounds/bg.py --size=%sx%s --name=%s --top=20}\
${image ~/.conky/x-calendar/images/clockbg1.png -p %s,0 -s 100x100}\
${image ~/.conky/x-calendar/images/clockbg1.png -p %s,0 -s 100x100}%s\n%s' % (bgwidth,bgheight,bgname, dgleft-10, dgleft+90,cal,clock)

